//+------------------------------------------------------------------+
//|Stochastic_Env.mq4.mq4
//| leonid553 & co)
//| http://www.tradersforum.net.ru/
//+------------------------------------------------------------------+
#property copyright "leonid553 & co"
#property link      "http://www.tradersforum.net.ru/"

//---- input parameters---------
extern int     Stochastic_period=8;
extern int     Env_period=25;
extern int     Env_shift=1;
extern double  Env_deviation=20;
extern double  Stochastic_price_field=0;
//------------------------------
extern int     TP=30;
extern int     SL=30;
extern double  Lot=0.1;
extern int     Slippage=3;
//-------------------
int   up_lim  =75;     // 
int   low_lim =25;     // 
//-------------------
int ticket;

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if (Env_deviation==0) Env_deviation=0.1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//*********************************************************************

double Stochastic_array[49];
//------   Stochastic-----------------
int    i=0;
while (i<50)
 {
Stochastic_array[i]= iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,Stochastic_price_field,MODE_MAIN, i);
i++;
 }
//------------------------------------------------------


ArraySetAsSeries(Stochastic_array,true);

double
En0_low=iEnvelopesOnArray(Stochastic_array,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,0);

double
En0_up=iEnvelopesOnArray(Stochastic_array,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,0);

double Stochastic_0=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,Stochastic_price_field,MODE_MAIN, 0);
double Stochastic_1=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,Stochastic_price_field,MODE_MAIN, 1);
 
//=====      =========================================================

int Orders=OrdersTotal ();     // -  
if (Orders==0)                 //   
  {  
//---------   ----------------------------
  if   (  /*(Stochastic_1<low_lim)  &&
          (Stochastic_0>low_lim)  &&*/
          (Stochastic_1<En0_low)  &&
          (Stochastic_0>En0_low)  )
   {
  ticket=OrderSend(Symbol(),0,Lot,Ask,Slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,CLR_NONE);
  if (ticket<0) { Print("   BUY #", GetLastError()); return (0); }              
   }
//------------------------------------------------------------------

//--------   ------------------------------
  if  ( /*(Stochastic_1>up_lim)  &&
          (Stochastic_0<up_lim)  &&  */
          (Stochastic_1>En0_up)  &&
          (Stochastic_0<En0_up)) 
   {       
  ticket=OrderSend(Symbol(),1,Lot,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,NULL,0,0,CLR_NONE);
  if (ticket<0) { Print("   SELL #", GetLastError()); return (0); }              
   }
  
//------------------------------------------------------------------
  }
//===============================================================================================


//----
   return(0);
  }
//+------------------------------------------------------------------+